#line 1 "F:/MikroC/KnigntRider/knightRider.c"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 17 "f:/mikroc/knigntrider/fader.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;





 typedef struct {

 uint aryuintStates[2];
 uint uintRepeat;
 } scheduleDef;

 typedef struct faderNode {
 unsigned uBounce : 1;
 unsigned uDirection : 1;
 unsigned uLoop : 1;
 unsigned uPin : 3;
 unsigned uState : 1;
 unsigned uStop : 1;
 byte* pPort;
 uint uintSteps;
 int intStep;
 int intLastStep;
 uint uintCtr;
 uint uintRepeat;

 void (*pCB)();

 scheduleDef* pSchItem;

 struct faderNode* pNext;
 } faderDef;


 boolean createFader(faderDef* pFader, byte* pPort, byte uPin,
 uint uintSteps, boolean blnDir, boolean blnBounce,
 boolean blnLoop, boolean blnState, boolean blnStopped,
 void (*pCB)());
 int createSchedule(uint uintInc, uint uintRepeat);
 void serviceFaders();
#line 17 "F:/MikroC/KnigntRider/knightRider.c"
typedef struct {
 byte bPin;
 uint uintPreDelay;
 uint uintPostDelay;
 faderDef fader;
} outputScheduleDef;

typedef struct {
 byte* pPort;
 byte bTotalSteps;
 unsigned uLoop : 1;
 unsigned uStop : 1;
 byte bIndex;
 byte bStage;
 uint uintCtr;
} animDef;

static volatile outputScheduleDef aryLEDseq[] = {
 { 0, 0,  ( ((uint)5000)  / 12)  },
 { 1, 0,  ( ((uint)5000)  / 12)  },
 { 2, 0,  ( ((uint)5000)  / 12)  },
 { 3, 0,  ( ((uint)5000)  / 12)  },
 { 4, 0,  ( ((uint)5000)  / 12)  },
 { 5, 0,  ( ((uint)5000)  / 12)  },
 { 6, 0,  ( ((uint)5000)  / 12)  },
 { 7, 0,  ( ((uint)5000)  / 12)  },

 { 6, 0,  ( ((uint)5000)  / 12)  },
 { 5, 0,  ( ((uint)5000)  / 12)  },
 { 4, 0,  ( ((uint)5000)  / 12)  },
 { 3, 0,  ( ((uint)5000)  / 12)  },
 { 2, 0,  ( ((uint)5000)  / 12)  },
 { 1, 0,  ( ((uint)5000)  / 12)  } };

static volatile animDef animTest = { &LATC,
 (sizeof(aryLEDseq) / sizeof(aryLEDseq[0])), 1 };
static outputScheduleDef* pCurAnim;
#line 65 "F:/MikroC/KnigntRider/knightRider.c"
void playAnimation(animDef* pAnim) {
 if ( pAnim->uStop ) {

 return;
 }

 if ( pAnim->bIndex >= pAnim->bTotalSteps ) {
 if ( !pAnim->uLoop ) {

 pAnim->uStop = 1;
 return;
 }

 pAnim->bIndex = 0;
 }
 pCurAnim = &aryLEDseq[pAnim->bIndex];

 switch((int)pAnim->bStage) {
 case 0:

 if ( pCurAnim->uintPreDelay == 0 ) {

 pAnim->bStage = 2;
 break;
 }
 pAnim->uintCtr = pCurAnim->uintPreDelay;
 pAnim->bStage = 1;
 break;
 case 1:

 if ( --pAnim->uintCtr == 0 ) {
 pAnim->bStage = 2;
 } else {
 break;
 }
 case 2:

 *pAnim->pPort = (1 << pCurAnim->bPin);

 pCurAnim->fader->intStep = pCurAnim->fader->uintSteps - 1;
 pCurAnim->fader->uStop = 0;

 if ( pCurAnim->uintPostDelay > 0 ) {
 pAnim->uintCtr = pCurAnim->uintPostDelay;
 pAnim->bStage = 3;
 } else {
 pAnim->bStage = 4;
 break;
 }
 case 3:

 if ( --pAnim->uintCtr == 0 ) {
 pAnim->bStage = 4;
 }
 break;
 case 4:

 pAnim->bIndex++;
 pAnim->bStage = 0;
 break;
 }
 serviceFaders();
}
#line 132 "F:/MikroC/KnigntRider/knightRider.c"
void interrupt() {
 playAnimation(&animTest);

 TMR0H = 0xF9;
 TMR0L = 0xC0;
 TMR0IF_bit = 0;
}
#line 142 "F:/MikroC/KnigntRider/knightRider.c"
void main() {

 int i, intSteps;

 intSteps = createSchedule(5, 0);

 for( i=0; i<animTest.bTotalSteps; i++ ) {
 outputScheduleDef* pStep;
 pStep = &aryLEDseq[i];
 createFader(&pStep->fader, animTest.pPort, pStep->bPin,
 (uint)intSteps, TRUE, FALSE,
 FALSE, FALSE, TRUE,  ((void*)0) );
 }

 ANSELC = 0;
 TRISC = 0;
 LATC = 0;


 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;

 TMR0H = 0xF9;
 TMR0L = 0xC0;
 TMR0IE_bit = 1;

 GIE_bit = 1;

 while( 1 ) {

 }
}
